<?
/*
Function gets file name for current log identified by service and date
*/
function getfilename($service,$date)
{
	checksession();
	global $api;
	/*
		Get Logpath dir from API 
	*/
  $api = createobject("api");
	$logdir = getfilevarpath($api->GetProperty("C_System_Storage_Dir_LogPath"), $_SESSION["INSTALLPATH"]);
	$lines = @file($_SESSION["INSTALLPATH"]."path.dat");
  $serverid = trim($lines[8]);
	/* 
	   Date format correction
	*/
	$date=str_replace('/','',$date); 
	if ($date=='') $date = date("Y/m/d",time());
	/*
	    prefix distribution depending on Service name{log type}
	*/
	switch (strtolower($service)){
		case 'smtp':
			$tempfile ="s";
		break;
		case 'av':
			$tempfile ="antivirus/";
		break;
		case 'as':
			$tempfile ="antispam/";
		break;
		case 'sreport':
			$tempfile ="reports/";
		break;
		case 'main':
			$tempfile ="maintenance/";
		break;
		case 'webmail':
			$tempfile ="webmail/";
		break;
		case 'sip':
			$tempfile ="sip/";
		break;
		case 'gw':
			$tempfile ="g";
		break;
		case 'control':
			$tempfile ="c";
		break;
		case 'ftp':
			$tempfile ="f";
		break;
		case 'pop3':
			$tempfile ="p";
		break;
		case 'im':
			$tempfile ="i";
		break;
		case 'imap':
			$tempfile ="m";
		break;
		case 'error':
			$tempfile ="e"; 
		break;
		
		//I does not know naming convention for theese log files
		case 'ima':
			$tempfile ="im/";
		break;

    }	
	return $logdir.$tempfile.$serverid.$date;
}
/*
Function returns content of the logfile depending on service and date
*/
function getlogs($service,$date,$from,$to,$stripdate)
{
	global $api;
	
	checksession();
	$ret='';
	$tempfile = getfilename($service,$date);
	$rotate = $api->GetProperty("C_System_Logging_General_LogRotation");
	if ($rotate!=0) {
	 $end = false;
    while (!$end)
      {
      $index =($i++);
      if ($index<10) $index="0".$index;
      if ($index==0) $index="00";
      $tempf=$tempfile.'-'.$index.".log";
      if (file_exists($tempf)){
  	  $lines = @file($tempf);
  	   if ($lines) foreach ($lines as $v)
          $ret.=processline($v,$from,$to,$stripdate);
      }else $end = true;
    }
  }else{
    $tempfile.=".log";
  	$lines = @file($tempfile);

  	if ($lines)	foreach ($lines as $v)
        $ret.=processline($v,$from,$to,$stripdate);
  } 	
	return nl2br(htmlspecialchars($ret));
	
}
function  processline($line,$from,$to,$stripdate)
{
    	eregi('([a-zA-Z]{0,}, [0-9]{1,2} [a-zA-Z]{3} [0-9]{0,}) ([0-9]{0,}):([0-9]{0,}):([0-9]{0,})',$line,$regs);
  		$repstr = $regs[1];
  		//Strip date
      if ($stripdate) $line = str_replace($repstr,"",$line);
  		//From to time 
  		$from_arr = explode(":",$from);
      $to_arr = explode(":",$to);
      $from = $from_arr[0]*3600+$from_arr[1]*60;
      $to = $to_arr[0]*3600+$to_arr[1]*60;
      $sec = $regs[2]*3600+$regs[3]*60+$regs[4];
  		if (($sec<=$to) && ($sec>=$from))
  		  $ret.= $line;
  		return $ret;
}
?>
