<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head>
<title>{title}</title>
<style>
body{
	font-family: Helvetica CE, Arial CE, Helvetica, Arial, sans-serif;
	font-size: 0.8em;
	padding: 10px;
}
table{
    cursor: default;
	border-collapse: collapse;
	empty-cells: show;
}
	table th{
		background-color: #ECE9D8;
		color: #000;
		text-align: left;
		text-indent: 5px;
		white-space: nowrap;
		border: 1px solid #D2CFBE;
		border-bottom-width: 3px;

		font-size: 0.9em;
		font-weight: normal;
	}
	table td{
		text-indent: 5px;
		border: 1px solid #D2CFBE;
		font-size: 0.8em;
	}
h1{
	font-size: 1.2em;
}
h2{
	font-weight: bold;
	font-size: 1em;
	margin-bottom: 0.3em;
	
	color: #3B619C;
}
table a{
	display: block;
	float: left;
	border: 2px outset white;
	color: #000;
	text-decoration: none;
	text-indent: 0;
	background-color: #ECE9D8;
	padding: 0 2px;
	margin: 1px;
}

table a:hover{
   border-style: inset;
}
table a:visited{
   border-style: inset;
   color:#AAA;
}


/* ???? */
.resultError{
	color: red;
	font-size: 17px;
	font-weight: bold;
}
.resultOk{
	color: green;
	font-size: 17px;
	font-weight: bold;
}
fieldset{
border:0px;
}
</style>

</head>

<body>
<h1>{title}</h1>
<p>{intro}</p>
{dynamic blocks}
	<h2>{optional *::isdomain}{domain}{/optional}{!optional *::isdomain}{account}{/optional} {*::account}</h2>
  <form name="challengeform" method="post" target="_blank" id="ch_frm" action="{URL}"/>
  <fieldset>	        
    <input type="hidden" name="id" value="{*::allids}"/>
    <input type="hidden" name="lang" value="{language}"/>
    <input type="hidden" name="to" value="{*::alltos}"/>
    <input type="hidden" name="from" value="{*::allfroms}"/>

    <select name="action">
      <option value="11">{authorizeall}</option>
      <option value="12">{acceptall}</option>
      <option value="13">{deleteall}</option>
      <option value="14">{blacklistall}</option>
      <option value="16">{deliveruntouched}</option>
      <option value="17">{blacklistuntouched}</option>
    </select>
    <button type="submit">{submit}</button>
  </form>
  <table border="0">
		<thead><tr><th>{sender}</th><th>{recipient}</th><th>{subject}</th><th>{date}</th><th>{time}</th><th>{location}</th><th>{actions}</th></tr></thead>
		<tbody>
			{dynamic *::items}<tr>
				<td>{*::from}</td>
				<td>{*::to}</td>
				<td>{*::subjectshort}</td>
				<td>{*::date}</td>
				<td>{*::hours}:{*::minutes} {*::am}</td>
				<td>{optional *::spamfolder}{type_spam}{/optional}{!optional *::spamfolder}{type_quarantine}{/optional}</td>
				<td>
					<a href="{URL}?action=1&lang={language}&id={*::id}&to={*::to}&from={*::from}">{authorize}</a>
					<a href="{URL}?action=2&lang={language}&id={*::id}&to={*::to}&from={*::from}">{accept}</a>
					<a href="{URL}?action=3&lang={language}&id={*::id}&to={*::to}&from={*::from}">{delete}</a>
					<a href="{URL}?action=4&lang={language}&id={*::id}&to={*::to}&from={*::from}">{blacklist}</a>
					<a href="{URL}?action=5&lang={language}&id={*::id}&to={*::to}&from={*::from}">{view}</a>
				</td>
			</tr>{/dynamic}
		</tbody>
	</table>
	<br/>
<form name="challengeform" method="post" target="_blank" id="ch_frm" action="{URL}"/>
  <fieldset>	        
    <input type="hidden" name="id" value="{*::allids}"/>
    <input type="hidden" name="lang" value="{language}"/>
    <input type="hidden" name="to" value="{*::alltos}"/>
    <input type="hidden" name="from" value="{*::allfroms}"/>

    <select name="action">
      <option value="11">{authorizeall}</option>
      <option value="12">{acceptall}</option>
      <option value="13">{deleteall}</option>
      <option value="14">{blacklistall}</option>
      <option value="16">{deliveruntouched}</option>
      <option value="17">{blacklistuntouched}</option>
    </select>
    <button type="submit">{submit}</button>
  </form>
{/dynamic}
</fieldset>
</form>
<p>{outro}</p>
</body></html>
