_me = frm_main.prototype;
function frm_main(){};

_me.__constructor = function(bAlreadySynced)
{
	//Hide copyright block
	var celm;
	if((celm = document.getElementById('gui.copyright'))){
		celm.style.display = 'none';
		celm = null;
	}

	//Create sound object
	this.sound = gui._create('sound','obj_sound');

	//Create Drag n Drop
	storage.library('dragndrop');
	this.dnd = new cDnD();

	var me = this;
	this.__cookieTimeout = 60000;

	// load libraries
	storage.library('class_old_message');
	storage.library('class_new_message');
	storage.library('class_item');
	storage.library('gw_others');

	//Synchro-set accounts dataset
	var aAccounts;
	//var accounts;
	if (!bAlreadySynced){
		aAccounts = WMAccounts.list();
		dataSet.add('accounts','',aAccounts);
	}
	else
		aAccounts = dataSet.get('accounts');

	// tento kod se muze odendat, jakmile prestaneme pouzivat ?frm=main... v URL


	if (!bAlreadySynced) {
		//Synchro-set storage dataset
		storage.library('wm_storage');
		dataSet.add('storage','',WMStorage.get({'resources':[
												'gw_groups',
												'mail_settings_default',
												'mail_settings_general',
												'layout_settings',
												'calendar_settings',
												'default_calendar_settings',
												'cookie_settings',
												'default_reminder_settings',
												'default_folders',
												'signature',
												'restrictions']}));
	}

	//Synchro-set folders dataset
	for (var sAccId in aAccounts){

		if (!aAccounts[sAccId]) continue;
        
		if (aAccounts[sAccId]['PRIMARY']) {
			if (!bAlreadySynced)
				dataSet.add('folders',[sAccId],WMAccounts.refresh({'aid':sAccId})[sAccId]);
		}
		else
		if (GWOthers.getItem('RESTRICTIONS','disable_otheraccounts') == 0)
			dataSet.add('folders',[sAccId],WMFolders.list({'aid':sAccId})[sAccId]);
	}


	//Obsluha pohledů
	this._lastView;
	this._defaultViews = {	'C':{'view':'list_view','sort':{'column':'CONTACT_FULLNAME','type':'asc'},'offset':0},
							'E':{'view':GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','event_view'),'sort':{'column':'EVENT_STARTDATE','type':'desc'},'offset':0},
							'J':{'view':'list_view','sort':{'column':'EVENT_STARTDATE','type':'desc'},'offset':0},
							'M':{'view':'mail_view','sort':{'column':'DATE','type':'desc'},'offset':0},
							'N':{'view':'list_view','sort':{'column':'EVNTITLE','type':'asc'},'offset':0},
							'F':{'view':'list_view','sort':{'column':'EVNLOCATION','type':'asc'},'offset':0},
							'Q':{'view':'mail_view','sort':{'column':'QDATE','type':'desc'},'offset':0},
							'QL':{'view':'list_view','sort':{'column':'SNDEMAIL','type':'asc'},'offset':0},
							'T':{'view':'list_view','sort':{'column':'TASK_ENDDATE','type':'desc'},'offset':0},
							'X':{'view':'nothing'}};

	this._defaultWindowSize = {'frm_compose':{'x':-1,'y':-1,'w':800,'h':600,'max':0},
							'frm_contact':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_distrib':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_event':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_task':{'x':-1,'y':-1,'w':600,'h':-1,'max':0},
							'frm_journal':{'x':-1,'y':-1,'w':600,'h':-1,'max':0},
							'frm_note':{'x':-1,'y':-1,'w':450,'h':-1,'max':0},
							'frm_dial':{'x':-1,'y':-1,'w':250,'h':-1,'max':0},
							'frm_file':{'x':-1,'y':-1,'w':450,'h':-1,'max':0}};

	//Načtení cookies
	storage.library('gw_others');
	var aCookies = GWOthers.get('COOKIE_SETTINGS','storage');

	var aViews;
	var aTree = [];
	var sActiveFolder = '';
	var oActiveFolder = {};
	var sSuggest = '';
	var nVerticalSlider;
	var nHorizontalSlider;
	var aWindowSize;
	
	if (aCookies['VALUES']){

		// Recipients suggestion
		dataSet.add('suggest_address','',aCookies['VALUES']['suggest_address'] || '');

		// Views
		try{
			var sArray = aCookies['VALUES']['views'];
			aViews = new Function("return "+sArray)();
		}
		catch(e){
			aViews = {};
		}

		// Open tree nodes
		try{
			var sArray = aCookies['VALUES']['tree'];
			aTree = sArray.split('|');

			if (aTree[0] == '')
			  aTree = [];
		}
		catch(e){}



		try{
			sActiveFolder = aCookies['VALUES']['folder'];
			nVerticalSlider = aCookies['VALUES']['vertical_slider'];
			nHorizontalSlider = aCookies['VALUES']['horizontal_slider'];
		}
		catch(e){}
		
		try{
			var sArray = aCookies['VALUES']['window_size'];
			aWindowSize = new Function("return "+sArray)();
			for(sFrm in this._defaultWindowSize){
				if(!aWindowSize[sFrm])
					aWindowSize[sFrm] = this._defaultWindowSize[sFrm];
			}
		}
		catch(e){
			aWindowSize = this._defaultWindowSize;
		}
	}

	if (typeof aViews != 'object')
		aViews = {};
	if (typeof aWindowSize != 'object')
		aWindowSize = this._defaultWindowSize;

	var aFolders = dataSet.get('folders');

	//Promazání cookies neexistujících folders
	if (count(aViews)){
		for(var sAccId in aViews){
			if (!aFolders[sAccId])
				delete aViews[sAccId];
			else
			for(var sFolId in aViews[sAccId])
				if (!aFolders[sAccId][sFolId])
					delete aViews[sAccId][sFolId];
		}
	}

	if (sActiveFolder){

		var aPos = sActiveFolder.split('/');
		var sAccId = aPos.shift();
		var sFolId = aPos.join('/');

		if (!aFolders[sAccId] || (sFolId && !aFolders[sAccId][sFolId]))
			sActiveFolder = '';
		else{
			oActiveFolder.aid = sAccId;
			if (sFolId) oActiveFolder.fid = sFolId;
		}
	}
	else{
		//homepage (odendat fid)
		sActiveFolder = sPrimaryAccount+'/INBOX';
		oActiveFolder = {'aid':sPrimaryAccount,'fid':'INBOX'};
	}

	//Přidání cookies nových folders
	for(var sAccId in aFolders)
		for(var sFolId in aFolders[sAccId])
			if (!aViews[sAccId] || !aViews[sAccId][sFolId])
			{
				if (!aViews[sAccId])
					aViews[sAccId] = {};

				aViews[sAccId][sFolId] = clone(this._defaultViews[aFolders[sAccId][sFolId]['TYPE']],true);
			}

	if (!count(aTree))
		aTree.push(sPrimaryAccount);

	dataSet.add('datagrid_views','',aViews);
	dataSet.add('folder_tree','',aTree);
	dataSet.add('active_folder','',''); //sActiveFolder se nastavuje az v selectView()
	dataSet.add('vertical_slider','',nVerticalSlider);
	dataSet.add('horizontal_slider','',nHorizontalSlider);
	dataSet.add('window_size','',aWindowSize);

	setTimeout('try{'+this._pathName+'.__cookieAutoSave();}catch(e){}',this.__cookieTimeout);

	/*** TREE ***/
	this._create('folders','obj_tree_folder_context','left');
	this.dnd.registr_drop(this.folders,['item','folder']);  // dat primo do  obj_tree_folder_context

	/*** TOP MENU 1 ***/
	this._create('hmenu1','obj_hmenu_basic','menu1');
	this._create('hmenu3','obj_hmenu_basic2','menu1');

	/*** TOP MENU 2 ***/
	this._create('hmenu2','obj_hmenu','menu2');
	this.hmenu2._fill({"logout":{"title":'',"arg":'logout'}});
	this.hmenu2._onclick = function(e,elm,id,arg){
		switch(arg){
			case 'logout':
			if (me.__cookieSave([me,'__logout']) == 2)
				me.__logout();
		}
	}

	//inspect2({sActiveFolder:sActiveFolder,oActiveFolder:oActiveFolder});
	//Aktivace dříve aktivního folderu
	if (sActiveFolder){
		gui.frm_main.folders._setActive(sActiveFolder);
		gui.frm_main.folders._handleNode(oActiveFolder);
	}

	//Nastaveni title = account
    var sPgTitle = GWOthers.getItem('LAYOUT_SETTINGS','title') || '';
	var aAccounts = dataSet.get('accounts');
	for(var mail in aAccounts){
		document.title = (sPgTitle?sPgTitle+' - ':'')+(aAccounts[mail].FULLNAME?aAccounts[mail].FULLNAME+' <'+mail+'>':mail);
		break;
	}
	
	//Expired Account
	if (aAccounts[sPrimaryAccount].EXPIRED)
		gui._create('expired','frm_passexpired');
};

_me._logout = function(){

	//catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
	var bReturn = false;
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__logoutOnDestruct = true;
			bReturn = true;
		}
	}

	if (bReturn) return;

	//logout user
};

_me._selectView = function(aFolder,sView,bUpdate,oDate,bForceUpdate){
	var me = this;

	// promazat datasety
	dataSet.remove('items','',true);
    dataSet.remove('mailview','',true);

	// HomePage
	if (!aFolder['fid']){
        aFolder['aid'] = sPrimaryAccount;
		aFolder['fid'] = 'INBOX';

/*
	    gui.frm_main.folders._setActive(aFolder['aid']+'/'+aFolder['fid']);
		if (this._lastView == 'home') return;
		if (gui.frm_main.main) gui.frm_main.main._destruct();
        this._lastView = 'home';

		this.hmenu3._fill({});
        
		gui.frm_main._create('main','frm_main_home');

		dataSet.add('active_folder','',aFolder['aid']);
		return;
*/
	}

	// ziskat typ folderu
	var sFolType = dataSet.get("folders",[aFolder['aid'],aFolder['fid'],'TYPE']);

	//Ziskat pohled a jeho nastaveni
	if (sView)
		dataSet.add('datagrid_views',[aFolder['aid'],aFolder['fid'],'view'],sView);
	else
		sView = dataSet.get('datagrid_views',[aFolder['aid'],aFolder['fid'],'view']);

	if (!sView){
        var aView = this._defaultViews[sFolType];
		dataSet.add('datagrid_views',[aFolder['aid'],aFolder['fid']],aView);
        sView = aView.view;
	}
	else
		var aView = dataSet.get('datagrid_views',[aFolder['aid'],aFolder['fid']]);

	// nastavit horni menu
    this.hmenu3._contextFill(sFolType,aFolder,sView,false);

	//Změnil se pohled?
	if (sView != this._lastView || bForceUpdate)
	{
		//Změnil se pohled v rámci stejného objektu?
		if ((sView == 'day_view' || sView =='week_view') && (this._lastView == 'day_view' || this._lastView =='week_view'))
		{
			//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
			if (!oDate){
                var oDate = new Date();
				if (this.main.calendar._selection && this.main.calendar._selection.startdate)
                    oDate.setQTime(this.main.calendar._selection.startdate);
				else {
					var aRange = this.main.calendar._range();
					if (aRange['start'])
						oDate.setQTime(aRange['start']);
				}
			}
/*
			switch(sView){
				case 'day_view':
					this.main._setDayView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
					break;
				case 'week_view':
					this.main._setWeekView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
			}
*/
		}
		else {

			if (this.main){
				if  (this._lastView == 'day_view' || this._lastView == 'week_view' || this._lastView == 'month_view')
					oDate = oDate || this.main._getDate();
				else
					oDate = new Date();

				this.main._destruct();
			}
			else
				oDate = new Date();

			switch(sView){
				case 'mail_view':
					this._create('main','frm_main_mail');
					if (aView.search)
     					this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'list_view':
					this._create('main','frm_main_datagrid');
					if (sFolType=='C' || aView.search)
						this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'day_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setDayView(date);
					break;

				case 'week_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setWeekView(date);
					break;
				case 'month_view':
					this._create('main','frm_main_calendar_month','','','items',oDate);
					break;
			}
		}
		this._lastView = sView;
	}
	else{
		switch(sView){
		case 'mail_view':
		case 'list_view':
			this.lister._value(0,true);

			if (dataSet.get('active_folder') != aFolder['aid'] + '/' + aFolder['fid']){
				if (sFolType=='C' || aView.search)
					this.main._showsearch(sFolType, aFolder['aid']+'/'+aFolder['fid']);
				else
					this.main._hidesearch(true);
			}
			break;
		case 'day_view':
		case 'week_view':
			//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
			if (!oDate){
				oDate = new Date();
				if (this.main.calendar._selection && this.main.calendar._selection.startdate)
                    oDate.setQTime(this.main.calendar._selection.startdate);
				else{
					var aRange = this.main.calendar._range();
					if (aRange['start'])
						oDate.setQTime(aRange['start']);
				}
			}
		}
	}

	switch(sView){
		case 'mail_view':
		case 'list_view':
			//vzdy refreshnout hlavicku DG
			//this.main.list._refreshHeader = true;

			//defaultni hodnoty pro lister
			this.lister._range(aView['offset']+this.lister._list());
			this.lister._value(aView['offset'],true);

			//Máme mailový pohled?
			if (sView == 'mail_view'){

				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type'],[this,'__synchroDatasetHandler',[aFolder['aid'],aFolder['fid']]]);

				var aActiveMails = dataSet.get('active_mails');
				if (!aActiveMails || !aActiveMails[aFolder['aid']] || !aActiveMails[aFolder['aid']][aFolder['fid']])
				 	dataSet.remove('mailview');
			}
			else
				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type']);

			break;

		case 'home':
			break;

		case 'day_view':
			this.main._setDayView(oDate);
            this.main._serverSort();

			break;
		case 'week_view':
			this.main._setWeekView(oDate);
            this.main._serverSort();

			break;
		case 'month_view':
            this.main._serverSort();

	}

	dataSet.add('active_folder','',aFolder['aid'] + '/' + aFolder['fid']);
};

/* pokud je posledni aktivni email v danem folderu otevre ho v mailview */
_me.__synchroDatasetHandler = function(sAccId,sFolId)
{
	var sActiveMail = dataSet.get('active_mails', [sAccId, sFolId]);

	if (sActiveMail){
		gui.frm_main.main.list._value([sActiveMail]);
		OldMessage.open([sAccId, sFolId, sActiveMail]);
	}
};

_me.__cookieSave = function(aHandler){
	GWOthers.set('COOKIE_SETTINGS',{'views':arrToString(dataSet.get('datagrid_views')),'tree':valuesToString(dataSet.get('folder_tree')),'folder':dataSet.get('active_folder'),'vertical_slider':dataSet.get('vertical_slider'),'horizontal_slider':dataSet.get('horizontal_slider'),'suggest_address':dataSet.get('suggest_address'),'window_size':arrToString(dataSet.get('window_size'))},'storage');
	return WMStorage.set({'resources':{'COOKIE_SETTINGS':dataSet.get('storage',['COOKIE_SETTINGS'])}},'storage','',aHandler); //velmi důležitý return!!!
};

_me.__cookieAutoSave = function(){
	if (this._destructed)
		return;

	this.__cookieSave();
	setTimeout('try{'+this._pathName+'.__cookieAutoSave();}catch(e){}',this.__cookieTimeout);
};

_me.__logout = function(){

	//#catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
//	var bReturn = false;
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__logoutOnDestruct = true;
			return;
//			bReturn = true;
		}
	}

	//if (bReturn) return;

	//#logout user
    var sURL = dataSet.get('main',['referrer_url']);

	auth.logout();

	//remove datasets
	dataSet.remove('accounts');
	dataSet.remove('folders','',true);
	dataSet.remove('items','',true);
	dataSet.remove('mailview','',true);
	dataSet.remove('active_mails');
	dataSet.remove('settings');

	// destruct parent form
	this._destruct();
	
	// destruct everything in gui
	gui._clean();

	//forward to external login homepage
	if (sURL)
        document.location.href = sURL;
	//create login page
    else
		gui._create('frm_login','frm_login');
};