_me = obj_mailview.prototype;
function obj_mailview(){};

_me.__constructor = function(){
	this._skipsaving = false;
	this._noupdate = false;

	// Browser detection
	this._MSIE = currentBrowser().indexOf('MSIE')>-1;

	this.__eHeader = this._getAnchor('header');
	this.__eSubject = this._getAnchor('subject');
	this.__eFrom = this._getAnchor('from');

	this.__FullHeaders = null;
    
	this.__eFrame = mkElement('iframe');
	this.__eFrame.setAttribute('frameBorder','no');
	this.__eFrame.setAttribute('marginWidth',0);
	this.__eFrame.setAttribute('marginHeight',0);
    this.__eFrame.height = '100%';
    
	this._getAnchor('frame').appendChild(this.__eFrame);

	this.__doc = this.__eFrame.contentDocument;
	if (typeof this.__doc == 'undefined' || this.__doc == null)
		this.__doc = this.__eFrame.contentWindow.document;

	var html =	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"+
				"<html>\n<head>\n"+
				(this._MSIE?'<link type="text/css" rel="stylesheet" href="client/skins/default/css/obj_mailview_body.css" />':'')+
				"\n</head>\n<body></body>\n</html>";

	this.__doc.open('text/html','replace');
	this.__doc.write(html);
	this.__doc.close();

	// Append Style Sheet (all browsers except MSIE)
	if (!this._MSIE){
		var link = this.__doc.createElement('link');
			link.setAttribute("type","text/css");
			link.setAttribute("rel","stylesheet");
			link.setAttribute("href","client/skins/default/css/obj_mailview_body.css");
			this.__doc.getElementsByTagName('head')[0].appendChild(link);
			link = null;
	}

	// Events
	var eFrame = this.__eFrame;
	var win = eFrame.contentWindow;
	function mouseEvn(e){
		var e = e || win.event;

		if (!window.document['on'+e.type]) return false;

 		var pos = getSize(eFrame);
		var evn = {"type":e.type,"clientX":e.clientX + pos.x,"clientY":e.clientY + pos.y,'target':(e.target || e.srcElement)};

		window.document['on'+e.type](evn);
	};

	if (win.addEventListener){
		win.addEventListener("mousemove", mouseEvn, false);
		win.addEventListener("mousedown", mouseEvn, false);
		win.addEventListener("mouseover", mouseEvn, false);
		win.addEventListener("mouseup", mouseEvn, false);
		win.addEventListener("click", mouseEvn, false);
		win.addEventListener("context", mouseEvn, false);
	}
	else{
		this.__doc.onmousemove = function(e){ mouseEvn(e); };
		this.__doc.onmousedown = function(e){ mouseEvn(e); };
		this.__doc.onmouseup = function(e){ mouseEvn(e); };
		this.__doc.onclick = function(e){ mouseEvn(e); };
		this.__doc.oncontext = function(e){ mouseEvn(e); };
		this.__doc.onmouseover = function(e){ mouseEvn(e); };
	}

	//Events

	var me = this;

	// FULL HEADERS
	this.__eSubject.ondblclick = function(e){

		//get info from dataset
		var aMails = dataSet.get('mailview');
        if (!aMails) return;

		for(var sAccId in aMails)
	  		for(var sFolId in aMails[sAccId])
		  	  	for(var sItId in aMails[sAccId][sFolId]);

		//Back to normal view
		if (me.__FullHeaders && me.__FullHeaders.aid == sAccId && me.__FullHeaders.fid == sFolId && me.__FullHeaders.iid == sItId){

			//get short headers
			WMItems.list({"aid": sAccId, "fid": sFolId, "iid": sItId, "values": OldMessage.__MAILINFO_VALUES},'mailview');

			me.__FullHeaders = '';
			return;
		}
		
		//Load All headers
		var MAILINFO_VALUES = [	'ALL_HEADERS', 'HTML', 'ATTACHMENTS', 'FLAGS', 'HAS_ATTACHMENT', 'PRIORITY',
								'STATIC_FLAGS', 'SMIME_STATUS', 'CONFIRM_ADDR'];
		
		// Async list item (refresh mailview) and refresh folders (folder tree)
		WMItems.list({"aid": sAccId, "fid": sFolId, "iid": sItId, "values": MAILINFO_VALUES},'mailview');

        me.__FullHeaders = {"aid": sAccId, "fid": sFolId, "iid": sItId};
	};
	
	// predelat do dedice
	this._listen('mailview');
};

	_me._header = function(aData){

		// clear attach
		if (this.attach){
			this.attach._destruct();
			delete this.attach;				//testnout jestli to je treba!
		}
		// clear header
		for (var i = this.__eHeader.childNodes.length-1;i>=0;i--)
			this.__eHeader.removeChild(this.__eHeader.childNodes[i]);


		if (!aData) return;

		var att,tr,th,td,aData2 = [];

		// Order and Langs
		if (aData['TO']){

//LINKS
/*
			var out = '', spliter = '', emails = MailAddress.splitEmails(aData['TO'].replace(/&gt;/gi,">").replace(/&lt;/gi,"<").replace(/&quot;/gi,'"'));
			for(var mno in emails){
				out += spliter + '<a href="javascript:void(0);">'+ emails[mno].entityify() +'</a>';
				spliter = '; ';
			}

			aData2[getLang('DATAGRID_ITEMS_VIEW::TO')] = out;

*/
			aData2[getLang('DATAGRID_ITEMS_VIEW::TO')] = aData['TO'];
			delete aData['TO'];
		}
		if (aData['CC']){
			aData2[getLang('DATAGRID_ITEMS_VIEW::CC')] = aData['CC'];
			delete aData['CC'];
		}
		if (aData['ATTACHMENTS']){
			aData2['ATTACHMENTS'] = aData['ATTACHMENTS'];
			delete aData['ATTACHMENTS'];
		}
		aData2 = arrConcat(aData2,aData);

		// create header
		for (var i in aData2){

			tr = mkElement('tr');
			this.__eHeader.appendChild(tr);

/*
			th = mkElement('th');
			th.style.width= "0.1%";
			td = mkElement('td');
			td.style.width= "99.9%";
*/

			if (i == 'ALL_HEADERS'){
				td = mkElement('td');
				td.style.width = "100%";
				td.className = 'obj_mailview_allheaders';
				td.colSpan = 2;
				tr.appendChild(td);
			}
			else {
				th = mkElement('th');
				th.style.width= "0.1%";
				td = mkElement('td');
				td.style.width= "99.9%";

				tr.appendChild(th);
				tr.appendChild(td);
			}

			if (i == 'ATTACHMENTS'){
				td.id = this._pathName+'attach';

				this._create('attach','obj_attach_mailview','attach');
				this.attach._aid = this.__aid;
				this.attach._fid = this.__fid;
				this.attach._iid = this.__iid;

				for (var j in aData2['ATTACHMENTS'])
					 this.attach._add({"name":aData2['ATTACHMENTS'][j]['values'].NAME,"size":aData2['ATTACHMENTS'][j]['values'].SIZE,"id":j,"type":aData2['ATTACHMENTS'][j]['values'].TYPE});

				i = getLang('DATAGRID_ITEMS_VIEW::ATTACHMENTS');
				th.innerHTML = i + ':';
			}
			else
			if (i == 'ALL_HEADERS')
				td.innerHTML = '<pre>'+aData2[i]+'</pre>';
			else{
				if (aData2[i].length>500)
					td.innerHTML = '<div class="scroll_header">'+aData2[i]+'</div>';
				else
					td.innerHTML = aData2[i];
                th.innerHTML = i + ':';
			}

			tr = null; th = null; td = null;
		}
	};

	_me._frame = function(v){
		if (typeof v != 'undefined')
			this.__doc.getElementsByTagName('body')[0].innerHTML = v;
		else
			return this.__doc.getElementsByTagName('body')[0].innerHTML;
	};
	
	_me.__update = function(sName)
	{
		var aItems = dataSet.get('items');
		var aMails = dataSet.get('mailview');


		if (!aItems || !aMails)
			this._value(); //"FROM":'',"TO":'',"SUBJECT":'',"HTML":'',"CC":''
		else {
			//Get Item info
			for(var sAccId in aMails)
	  			for(var sFolId in aMails[sAccId])
	  	  			for(var sItId in aMails[sAccId][sFolId]);

			//disable full headers
			if (this.__FullHeaders && (this.__FullHeaders.aid != sAccId || this.__FullHeaders.fid != sFolId || this.__FullHeaders.iid != sItId))
                this.__FullHeaders = '';

			if (!aItems[sAccId] || !aItems[sAccId][sFolId] || !aItems[sAccId][sFolId][sItId]){
				this._value();
				return;
			}

			aItems = aItems[sAccId][sFolId][sItId];
			
			aMails = clone(aMails[sAccId][sFolId][sItId]);

			delete aMails.aid;
			delete aMails.fid;
			delete aMails.FLAGS;
			delete aMails.STATIC_FLAGS;
			delete aMails.HAS_ATTACHMENT;
			delete aMails.SMIME_STATUS;
			delete aMails.PRIORITY;
			delete aMails.CONFIRM_ADDR;
			delete aMails.DATE;
			delete aMails.REPLY_TO;

            aMails.AID = sAccId;
			aMails.FID = sFolId;
			aMails.IID = sItId;
			aMails.SUBJECT = aItems['SUBJECT'] || aItems['SNDSUBJECT'];
			aMails.FROM = aItems['FROM'] || aItems['SNDEMAIL'];

			this._value(aMails);
		}
	};

	_me.__showImages = function(bHide) {

		if (bHide){
			var elm = this.__doc.getElementById(this._pathName+'frame_images');
			if (elm){
			    elm.parentNode.removeChild(elm);
			    elm = null;
			}
			return;
		}

		if (!this.__aImages)
			return;

		var sImgFrame = '<div id="'+this._pathName+'frame_images" class="obj_mailview_images">';
		var sFullPath = this.__aid+'/'+this.__fid+'/'+this.__iid;
		var aURL;
		for (var i in this.__aImages) {
			aUrl = {'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':sFullPath+'/'+this.__aImages[i]};
			sImgFrame += '<img src="server/download.php?' + buildURL(aUrl) + '" alt="' +i+ '" title="' +i+ '" />';
		}
		sImgFrame += '</div>';

		this.__doc.getElementsByTagName('body')[0].innerHTML += sImgFrame;
	};

	_me._print = function(){
		if (!this.__aid || !this.__fid || !this.__iid || !this.__doc) return false;

		/*
frames["IframeName"].focus();
frames["IframeName"].print();
		*/

		this.__eFrame.contentWindow.focus();
		this.__eFrame.contentWindow.print();
		
		return true;
	};

	_me._value = function(aData){

		if (!aData){

			this.__aid = '';
			this.__fid = '';
			this.__iid = '';

            this.__FullHeaders = '';

			this.__eSubject.innerHTML = '';
			this.__eFrom.innerHTML = '';
			this.__aImages = {};
        	if (this.btn_show) this.btn_show._destruct();
			this._frame('');
			this._header();
			return;
		}

		/*
		if (this.__FullHeaders)
		    addcss(this._getAnchor('scroll'),"obj_mailview_scroll");
		else
			removecss(this._getAnchor('scroll'),"obj_mailview_scroll");
		*/
		// HTML has higher priority than TEXT
		if (aData['HTML'])
			delete aData['TEXT'];

		var aHeaders = {};
		var sBody = '';
		this.__aImages = {};
		for (var i in aData){
			switch(i){
				case 'BASE_URL': break;
				case 'SUBJECT':
					if (Is.String(aData[i]))
						this.__eSubject.innerHTML = aData[i].entityify();
					else
						this.__eSubject.innerHTML = getLang('MAIL_VIEW::NOSUBJECT');
					break;

				case 'FROM':
					if (Is.String(aData[i])){
// LINKS
/*
						var emails = MailAddress.splitEmails(aData[i]);
						for(var mno in emails){
							this.__eFrom.innerHTML += '<a href="javascript:void(0);">'+ emails[mno].entityify() +'</a>';
						}
*/
						this.__eFrom.innerHTML = aData[i].entityify();
					}
					else
						this.__eFrom.innerHTML = '';
					break;

				case 'HTML':
					if (aData[i]) sBody = aData[i];
					break;
				case 'TEXT':
					if (aData[i]) sBody = aData[i].entityify();
					break;

				case 'AID':
					this.__aid = aData[i];
					break;

				case 'FID':
					this.__fid = aData[i];
					break;

				case 'IID':
					this.__iid = aData[i];
					break;

				case 'ATTACHMENTS':
					for(var n in aData[i]) {
						aData[i][n]['values']['NAME'] = aData[i][n]['values']['NAME'].entityify();
						if (aData[i][n]['values']['TYPE'].indexOf('image') == 0)
							this.__aImages[aData[i][n]['values']['NAME']] = n;
					}

					aHeaders[i] = aData[i];
				break;

				// headers
				default	:
					if(Is.String(aData[i])) aHeaders[i] = aData[i].entityify();
			}
		}

		if (sBody){

			var date = dataSet.get('items',[this.__aid,this.__fid,this.__iid,'DATE']);
			if (date){
				var oDate = new Date();
					oDate.setUNIX(date);
			}

			//add target to links
			//sBody = sBody.replace(/\<[aA]\b/gm,'<a target="_blank" ');

			sBody = '<div class="msg_header">'+
			'<h1>'+ (aData['SUBJECT']?aData['SUBJECT'].entityify():'') +'</h1>'+
			'<table>'+
			'<tr><td width="0%">From:&nbsp;</td><td width="100%">'+ (aData['FROM']?aData['FROM'].entityify():'') +'</td>'+(oDate?'<td width="0%" valign="top" nowrap>'+(oDate?oDate.toWMString():'')+'</td>':'')+'</tr>'+
			(aData['TO']?'<tr><td width="0%">To:&nbsp;</td><td width="100%" colspan="2">'+ aData['TO'].entityify() +'</td></tr>':'')+
			'</table></div>' + sBody;

			this._frame(sBody);


			var url = this.__doc.URL;
			var pos = url.lastIndexOf('/');
				url = url.substr(0,url.lastIndexOf('/')+1);

			//add target and BASE to links
			if (aData['BASE_URL']){
				if (!(/\/$/gi.test(aData['BASE_URL'])))
					aData['BASE_URL'] += '/';
				if (!(/^((http)|(https))\:/gi.test(aData['BASE_URL'])))
					aData['BASE_URL'] = 'http://' + aData['BASE_URL'];
			}
			

			var a = this.__doc.getElementsByTagName('a');
			var r = /^((http)|(https)|(ftp)|(mailto))\:/gi;
			var h =  new RegExp("^"+ url.quoteMeta(),"gi");
			
			for (var i = 0; i<a.length; i++){
				a[i].target = '_blank';
				if (aData['BASE_URL'])
					a[i].href = a[i].href.replace(h,aData['BASE_URL']);
			}

			//change URLs for links and img
			if (aData['BASE_URL']){
				var a = this.__doc.getElementsByTagName('link');
				for (var i = 1; i<a.length; i++)  //1 because we skip our CSS
					a[i].href = a[i].href.replace(h,aData['BASE_URL']);

				var a = this.__doc.getElementsByTagName('img');
				for (var i = 0; i<a.length; i++)
					a[i].src = a[i].src.replace(h,aData['BASE_URL']);
			}
		}
		else
			this._frame('');

		this._header(aHeaders);
		
		//show images
        if (count(this.__aImages)>0){
            if (!this.btn_show){
				this._create('btn_show','obj_checkbox','button');
				this.btn_show._title('ATTACHMENT::SHOW_IMAGES');
				
				this.btn_show._onclick = function(){
                    this._parent.__showImages(!this._value());
				};
			}

			storage.library('gw_others');
			if (parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','auto_show_images')) == 1){
				this.btn_show._value(1);
				this.__showImages();
			}
			else{
                this.btn_show._value(0);
				this.__showImages(1);
			}
        }
        else
        if (this.btn_show)
            this.btn_show._destruct();

/*
		storage.library('gw_others');
		if (parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','auto_show_images')) == 1){
			if (this.btn_show)
			    this.btn_show._destruct();

			this.__showImages();
		}
		else{
			if(!this.btn_show){
				this._create('btn_show','obj_button','button');
		        this.btn_show._value('ATTACHMENT::SHOW_IMAGES');

			}
			if (count(this.__aImages))
				this.btn_show._disabled(0);
			else{
                this.btn_show._value('ATTACHMENT::SHOW_IMAGES');
				this.btn_show._disabled(1);
			}
		}
*/

	};