_me = obj_popup.prototype;
function obj_popup(){};
/**
 *
 *		_ondock
 *		_onundock
 *		_onresize
 **/
_me.__constructor = function(owner){
	this._owner = owner;

	this._resizable	= true;
	this._closable	= true;
	this._dockable	= true;
	this._moveble	= true;
	this._is_max	= 0;

	this.__zindex;
	this.__position; // position memory for fullscrean

	var me = this;

	/* docking */
	this._mydock;

	/* target elements */
	this.__eTitle		= document.getElementById(this._anchors['title']);
	this.__eContainer	= document.getElementById(this._anchors['container']);
	this.__eMain		= document.getElementById(this._anchors['main']);

	/* set zindex */
	this.__eContainer.style.zIndex = this.__zindex = maxZIndex.get();
	this._add_destructor('__destructor');

	/* onclose event */
	this._add_destructor('_onclose');

	var sResize;
	this.__eContainer.onmousemove = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (this !== elm) return;

		if (!me._resizable) {
			this.style.cursor = 'default';
			return;
		}

		var elmleft  = elm.offsetLeft,
			elmtop   = elm.offsetTop,
			elmwidth = elm.offsetWidth,
			elmheight= elm.offsetHeight;

		// left part
		if (e.clientX - elmleft<9){
			// top corner
			if (e.clientY - elmtop<9){
				this.style.cursor = 'se-resize';
				sResize = 'lt';
			}
			// bottom corner
			else
			if ((elmtop + elmheight) - e.clientY < 9){
				this.style.cursor = 'sw-resize';
				sResize = 'lb';
			}
			// side
			else{
				this.style.cursor = 'w-resize';
				sResize = 'l';
			}
		}
		// right part
		else
		if ((elmleft + elmwidth) - e.clientX<9){
			// top corner
			if (e.clientY - elm.offsetTop<9){
				this.style.cursor = 'sw-resize';
				sResize = 'rt';
			}
			// bottom corner
			else
			if((elmtop + elmheight) - e.clientY < 9){
				this.style.cursor = 'se-resize';
				sResize = 'rb';
			}
			// side
			else{
				this.style.cursor = 'w-resize';
				sResize = 'r';
			}
		}
		// center
		else{
			this.style.cursor = 's-resize';
			// top
			if (e.clientY - elmtop<8)
				sResize = 't';
			// bottom
			else
			if ((elmtop + elmheight) - e.clientY < 8)
				sResize = 'b';
		}
	}

	/* REMOVE EVENT */
	var tmpEvnUp = window.document.onmouseup;
	var tmpEvnMv = window.document.onmousemove;
	function dispatch(e){
		window.document.onmousemove = tmpEvnMv || null;
		window.document.onmouseup   = tmpEvnUp || null;
		tmpEvnUp = null;
		tmpEvnMv = null;
	};


	this.__eContainer.onmousedown = function(e){

		var e = e || window.event;
		var elm = e.target || e.srcElement;

		//pass focus to source element
		try{elm.focus(true);}catch(er){}

		// set max zindex
		me._focus();

		// resize event
		if (this === elm){
			if (!me._resizable) return;
			me.__resize (e,sResize);
		}
		else
		switch (elm.id){
			// move
			case me._anchors['top']:
			case me._anchors['title']:
				me.__eContainer.focus();
				if (!me._moveble) return;

				var difX = e.clientX - me.__eContainer.offsetLeft;
				var difY = e.clientY - me.__eContainer.offsetTop;

				document.onmousemove = function(e){
					var e = e || window.event;
					me._place(e.clientX - difX,e.clientY - difY);
				}
				break;

			// maximalize
			case me._anchors['max']:
				me._maximize();

				if (me._onresize) me._onresize(e,'max');
				me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'max'});
				break;
			// minimalize
			case me._anchors['min']:
				me._dock();
				break;
			// close
			case me._anchors['rem']:
				me._close();
				break;
		}

		window.document.onmouseup = dispatch;
	};
};

_me._maximize = function(){
	if (!this._resizable) return;

	if (this.__position){
		this._resizable	= true;
		this._moveble		= true;
		this._is_max    = 0;

		this._place(this.__position.x,this.__position.y,this.__position.w,this.__position.h);
		delete this.__position;
	}
	else{
		var oCont = this.__eContainer;
		this.__position	= {"x":oCont.offsetLeft,"y":oCont.offsetTop,"w":oCont.offsetWidth,"h":oCont.offsetHeight};
		this._resizable	= false;
		this._moveble		= false;
		this._is_max    = 1;
		this._place(0,0,document.body.offsetWidth ,document.body.offsetHeight);
	}
}


_me._dock = function (skip){
	var dock = this._mydock || gui._dock;

	if (!this._dockable || !dock) return;
	if (this._ondock && !this._ondock(dock)) return;

	this._main.style.display = 'none';
	this._docked = true;

	if (!skip) dock._add(this,this._title());

	return true;
};


_me._undock = function (skip){
	var dock = this._mydock || gui._dock;
	if (!dock) return;
	if (this._onundock && !this._onundock(dock)) return;

	this._docked = false;
	this._main.style.display = 'block';

	if (!skip) dock._remove(this);
	return true;
};

// _me._ondock = function(){};
// _me._onundock = function(){};

_me.__resize = function(e,sResize){



	var me = this;
	var difX,difY,dif1,dif2,dif3,dif4;

	switch(sResize){
	case 't' :
		difY = e.clientY;
		dif1 = this.__eMain.offsetHeight;
		dif2 = this.__eContainer.offsetTop;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;
			var size1 = dif1 - (evn.clientY - difY);
			var size2 = dif2 + (evn.clientY - difY);

			if (size1>29){
				me.__eMain.style.height	= size1 + 'px';
				me.__eContainer.style.top = size2 + 'px';

				/*** resize event ***/
				if (me._onresize) me._onresize(e,'t');
				me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'t'});
			}
		}
		break;

	case 'lt':
		difY = e.clientY;
		difX = e.clientX;
		dif1 = this.__eMain.offsetHeight;
		dif2 = this.__eContainer.offsetTop;
		dif3 = this.__eContainer.offsetWidth;
		dif4 = this.__eContainer.offsetLeft;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;
			var size1 = dif1 - (evn.clientY - difY);
			var size2 = dif2 + (evn.clientY - difY);

			var size3 = dif3 - (evn.clientX - difX);
			var size4 = dif4 - (difX - evn.clientX);

			if (size1>29){
				me.__eMain.style.height	= size1 + 'px';
				me.__eContainer.style.top		= size2 + 'px';
			}
			if (size3>199){
				me.__eContainer.style.width = size3 + 'px';
				me.__eContainer.style.left  = size4 + 'px';
			}

			/*** resize event ***/
			if (size1>29 || size3>199){
				if (me._onresize) me._onresize(e,'lt');
				me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'lt'});
			}
		}
		break;

	case 'l' :
		difX = e.clientX;
		dif1 = this.__eContainer.offsetWidth;
		dif2 = this.__eContainer.offsetLeft;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;

			var size1 = dif1 - (evn.clientX - difX);
			var size2 = dif2 - (difX - evn.clientX);

			if (size1>199){
				me.__eContainer.style.width = size1 + 'px';
				me.__eContainer.style.left  = size2 + 'px';

				/*** resize event ***/
				if (me._onresize) me._onresize(e,'l');
				me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'l'});
			}
		}
		break;

	case 'lb':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = this.__eContainer.offsetWidth;
		dif2 = this.__eContainer.offsetLeft;
		dif3 = this.__eMain.offsetHeight;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;

			var size1 = dif1 - (evn.clientX - difX);
			var size2 = dif2 - (difX - evn.clientX);
			var size3 = dif3 + (evn.clientY - difY);

			if (size1>199){
				me.__eContainer.style.width = size1 + 'px';
				me.__eContainer.style.left = size2 + 'px';
			}
			if (size3>29)
				me.__eMain.style.height = size3 + 'px';

			/*** resize event ***/
			if (size1>199 || size3>29){
				if (me._onresize) me._onresize(e,'lb');
				me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'lb'});
			}
		};

		break;
	case 'b' :
		difY = e.clientY;
		dif1 = this.__eMain.offsetHeight;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;
			var size = dif1 + (evn.clientY - difY);
			if (size>29){
				me.__eMain.style.height = size + 'px';

				/*** resize event ***/
				if (me._onresize) me._onresize(e,'b');
				me.__exeEvent('onresize',e,{"owner":me,"main":me.__eContainer,"body":me.__eMain,"type":'b'});
			}
		}
		break;
	case 'rb':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = me.__eContainer.offsetWidth;
		dif2 = me.__eMain.offsetHeight;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;

			var size1 = dif1 + evn.clientX - difX;
			var size2 = dif2 + evn.clientY - difY;
			if (size1>199)
				me.__eContainer.style.width = size1 + 'px';
			if (size2>29)
				me.__eMain.style.height = size2 + 'px';

			/*** resize event ***/
			if (size1>199 || size2>29){
				if (me._onresize) me._onresize(e,'rb');
				me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'rb'});
			}
		}
		break;
	case 'r' :
		difX = e.clientX;
		dif1 = me.__eContainer.offsetWidth;
		//dif2 = me.__eMain.offsetWidth; //use if uncomment div.obj_popup .obj_popupmain{ _width: auto}
		
		window.document.onmousemove = function(evn){
			var evn = evn || window.event;
			var size1 = dif1 + (evn.clientX - difX);

			if (size1<200) size1 = 199;

			me.__eContainer.style.width = size1 + 'px';
			//me.__eMain.style.width = (size1 + dif2 - dif1) + 'px';

			/*** resize event ***/
			if (me._onresize) me._onresize(e,'r');
			me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'r'});
		}

		break;
	case 'rt':
		difX = e.clientX;
		difY = e.clientY;
		dif1 = this.__eContainer.offsetWidth;
		dif2 = this.__eMain.offsetHeight;
		dif3 = this.__eContainer.offsetTop;

		window.document.onmousemove = function(evn){
			var evn = evn || window.event;
			var size1 = dif1 + (evn.clientX - difX);
			var size2 = dif2 - (evn.clientY - difY);
			var size3 = dif3 + (evn.clientY - difY);// + dif2 - difY;

			if (size1>199)
				me.__eContainer.style.width = size1 + 'px';

			if (size2>29){
				me.__eMain.style.height = size2 + 'px';
				me.__eContainer.style.top = size3 + 'px';
			}

			/*** resize event ***/
			if (size1>199 || size2>29){
				if (me._onresize) me._onresize(e,'rt');
				me.__exeEvent('onresize',e,{"owner":me,"main":me._main,"body":me.__eContainer,"type":'rt'});
			}
		}
		break;
	}
}

_me._title = function(sVal,bText){
	if (typeof sVal == 'undefined')
		return this.__eTitle.innerHTML;
	else
	if (bText)
		this.__eTitle.innerHTML = sVal.escapeHTML();
	else
		this.__eTitle.innerHTML = getLang(sVal);
};

_me._autoSize = function(){
	this.__eContainer.style.height = 'auto';
	//this.__eTable.style.width = 'auto';
};

_me._place = function(x,y,w,h){
	if (x>=0)
		this.__eContainer.style.left = (x)+'px';
	if (y>=0)
		this.__eContainer.style.top  = (y)+'px';

	if (w || h) this._size(w,h,1);
	
	if (!x && !y && !w && !h)
		return getSize(this.__eContainer);
};

_me._size = function (w,h,skip){
	var tmp;

	if (w>199){
		this.__eContainer.style.width = w+'px';

		if (!skip){
			tmp = document.body.clientWidth - w;
			tmp = tmp<0?0:tmp;
			tmp = Math.round(tmp/2)

			this.__eContainer.style.left = (tmp<0?0:tmp)+'px';
		}
	}
	
	h += this.__eMain.offsetHeight - this.__eContainer.offsetHeight;
	if (h>29){
		this.__eMain.style.height = h+'px';

		if (!skip){
			tmp = document.body.clientHeight - h;
			tmp = tmp<0?0:tmp;
			tmp = Math.round(tmp/2)

            this.__eContainer.style.top = (tmp<0?0:tmp)+'px';
		}
	};
};

_me._close = function(){
	if (!this._closable || (this._onclose && !this._onclose())) return;
    this._remove_destructor('_onclose');
	this._destruct();
};

_me._focus = function (){

	if (this._docked) this._undock();

	maxZIndex.remove(this.__zindex);
	this.__eContainer.style.zIndex = this.__zindex = maxZIndex.get();

	// modal window
	if (this.__modaldiv)
	    this.__modaldiv.style.zIndex = (this.__zindex-1);
};

_me._isModal = function(){
	return this.__modaldiv?true:false;
};

_me._modal = function(b){
	if(b && !this.__modaldiv){
		//modal window
		this.__modaldiv = mkElement("div",{className:'obj_popup_modaldiv'});
		this.__modaldiv.style.zIndex = parseInt(this.__zindex)-1;
	    this._main.insertBefore(this.__modaldiv,this.__eContainer);
    }
    else
	if(!b && this.__modaldiv){
        this._main.removeChild(this.__modaldiv);
        this.__modaldiv = null;
    }
};

_me._defaultSize = function() {
	var aSize = dataSet.get('window_size');
	if (Is.Defined(aSize[this._type])) {
		aSize = aSize[this._type];
		var x = parseInt(aSize['x']);
		var y = parseInt(aSize['y']);
		var w = parseInt(aSize['w']);
		var h = parseInt(aSize['h']);

		if (Is.Number(x) && Is.Number(y) && x > -1 && y > -1) {
			if (Is.Number(w) && w > -1) {
				if (Is.Number(h) && h > -1)
					this._place(x,y,w,h);
				else
					this._place(x,y,w);
			}
			else
				this._place(x,y);
		}
		else if (Is.Number(w) && w > -1) {
			if (Is.Number(h) && h > -1)
				this._size(w,h);
			else
				this._size(w);
		}
		
		if (aSize['max'])
			this._maximize();
	}
	
	// register function that will store current size
	this._add_destructor('__rememberSize');
}

_me.__rememberSize = function(){

	// make object visible so that its size can be stored
	if (this._main.style.display.toLowerCase() == "none")
		this._main.style.display = "block";

	var aSize;
	if (this._is_max)
		aSize = this.__position;
	else
		aSize = this._place();
	
	aSize['max'] = this._is_max;
	dataSet.add('window_size',[this._type],aSize);
}

/**
 * @brief: destructor
 * @date : 4.7.2006 14:38:46
 **/
_me.__destructor = function(){
	// remove object's zindex
	maxZIndex.remove(this.__zindex);
};

/**
 * @brief: onclose method
 **/
//_me._onclose = function(){}
