<?php
/* 
	Menu tree node class
  	used to handle all things around single tree node 
*/
class cMTreeNode
{
	//Private
	var $pData;
	var $Childs;
	//Public
	var $mtnCollapse;
	var $mtnID;
	/*
		Constructor for this class stores data of the node and inicializate vars
	*/
	function cMTreeNode($val,$key)
	{
		$this->pData=$val["ATTRIBUTES"];

		if (!isset($this->pData["FILE"]))
			$this->pData["FILE"]='mainframe.html';
		$this->mtnCollapse=0;
		$this->mtnID=$key; 
	}
	/* 	
		Method : MTNPrint
	   	DEscription: Prints the node informations, recursive - steps through all 
		              child nodes
	*/
	function MTNPrint($location,$directory,&$mtNodeCount,&$inarray)
	{
		global $alang;
		global $skin_dir;
		//Increase nr. of nodes
		$mtNodeCount++;
		/*
		Inarray is array used to set all menu tree variables
		$inarray[$mtNodeCount] stands for current menu node
		*/
		$item["name"]=$alang[$this->pData["LABEL"]];
		$item["data"]=count($this->Childs);
		$item["root"]=$location;
		$this->pData['root'] = $location;
		if ($this->pData["FILE"]=='mainframe.html'){
				$item["alink"]=$directory.$this->pData["FILE"].'?treenode='.$this->pData["ID"];
			  	if ($this->pData["ID"]=='DOMAINS') $item["alink"].='&dac=1&menulink=1'; 
		}else
		@$item["alink"]=$directory.$this->pData["FILE"];
		@$item["target"]='main_win';		
		@$item["ico"]='images/tree/'.$this->pData["ICON"];
		@$item["modes"] = explode ("|", $this->pData["MODE"]);
		@$item["js"]='setLastNode(this.id);sethelpid("'.$this->pData["HELPID"].'");setInfoValue("'.$skin_dir.'images/tree/'.$this->pData["ICON"].'","'.$alang[$this->pData["LABEL"]].'");';
		//If this node has some childs, do it for each of them(Recursive) 
		$inarray[] = $item;
		if (isset($this->Childs))
			foreach($this->Childs as $node_key => $node_val){
				//Location in menu structure separated by '\' character
				$loc=$location.'/'.$node_val->pData["ID"];
				//$directory is current directory for parent node -> $dir is current node home directory
				@$dir=$directory.$node_val->pData["FOLDER"];
				$node_val->MTNPrint($loc,$dir,$mtNodeCount,$inarray);
			}
	}
}
?>
