<?
require_once "inc/syntax/clsstdgrid.php";

/********** Quarantine GRID  - XML source *************/
class cChallengeGrid extends cStdGrid
{
  //Flags - type of queue (Quarantime,Whitelist,Greylist)
	function cChallengeGrid($option, 
                          $name,
                          $count = false, 
                          $sender = false, 
                          $owner = false, 
                          $domain = false)
	{
		$this->Name = $name;

    $this->Item = new cStdItem(8,";SEP;SEP;SEP;SEP;SEP;SEP;");

    switch(strtolower($option['ATTRIBUTES']['PARAM']))
    {
      case 'quarantine':
        $this->type = 2;
      break;
      case 'blacklist':
        $this->type = 0;
      break;
      case 'whitelist':
      default:
        $this->type = 1;
      break;
    }
    if($count) $this->counter = $count;

		$this->sender = $sender;
		$this->owner = $owner;
		$this->domain = $domain;
		
	}

	/* Gets buffer from file */
	function getBuffer()
	{
		global $formapi;
		$query = " WHERE SndAuthorized = '".$this->type."'";
		if ($this->sender)
		  $query.=" AND SndEmail LIKE '".$this->sender."%'";
		if ($this->owner)
		  $query.=" AND SndOwner LIKE '".$this->owner."%'";
		
		if ($_SESSION['ACCOUNT']=='DOMAINADMIN')
		{
     $query.=" AND (";
     $list = getdomainlist();
     foreach($list as $dom)
     {  
      $query.= "SndDomain LIKE '".$dom['DOMAIN']."%'";
      if ($count++ < count($list)-1) $query.= " OR ";
     }  
     $query.=")";     
    } else {
      if ($this->domain)
		    $query.=" AND SndDomain LIKE '".$this->domain."%'";
    
    }

    //if ($this->counter!=''){
      $this->Buffer = $formapi->QuarantineList('', $query,$this->counter);
   /* }else {
      $this->Buffer = $formapi->QuarantineList('', $query);
   }*/
   }  
 	
	/* Build grid from buffer */
	function loadFromBuffer()
	{
	    
		  if ($this->Buffer){


      $ic=0;
			/* explode buffer to lines */
			$lines = explode(CRLF,$this->Buffer);

			//Parse lines
			for ($i=0;$i<count($lines);$i++){
				$item = array();
				if ($lines[$i]=="") continue; // skip blank lines
				if ($this->Item->Length==1) $item[0]= $lines[$i];
				else{
					$pom = $lines[$i];
					for ($j=0;$j<$this->Item->Length-1;$j++){
						$pom = explode($this->Item->Seps[$j],$pom,2);
						if ($j==5)
						{
              $date = getDate(jdtounix($item[1]));
              $hours = intval($pom[0]/3600).":";
              $time =  $hours.intval(($pom[0]-$hours*3600)/60);
              
              $pom[0] = $date['year'].'-'.$date['mon'].'-'.$date['mday'].' '.$time;
              
            }
            $item[$j] = $pom[0];
						$pom = $pom[1];
					}
					$item[$j] = str_replace(";","",$pom);
				}
				$items[$ic++] = $item;
			}
			$this->Data = $items;
		}

	}
  function Save()
  {	      
    $noSaveActions = array(0=>'ch_whitelist',
                           1=>'ch_blacklist',
                           2=>'ch_delete',
                           3=>'ch_deliver',
                           4=>'ch_refresh',
                           4=>'g_refresh',
                           4=>'g_delete',
                           5=>'g_authorize',
			   6=>'bw_blacklist',
			   7=>'bw_whitelist');
    if(!(in_array($_REQUEST['gridaction'],$noSaveActions) || $this->type==2))
    {
     $api = createobject("api");
     
     if ($this->Data) foreach($this->Data as $ajtem){
        $list = $api->QuarantineList(''," WHERE sndAuthorized='".$this->type."' AND sndEmail = '".$ajtem[0]."' AND sndOwner ='".$ajtem[4]."' ",0);
        if ($list=='') {
          $api->QuarantineAdd($ajtem[4]?$ajtem[4]:'*',$ajtem[0],$this->type);     
        }
     }
    }
  }
		
  function getGridButtons($option,$type)
	{
	  global $alang,$_REQUEST,$formapi,$value;
		@$files = $option["SOURCE"][0]["FILE"][0]["ATTRIBUTES"];
		@$dialog = $files["DIALOG"];
		@$file = $files["NAME"];
		@$comment = $files["COMMENT"];
		if ($option["BUTTONS"][0]["BUTTON"])
		foreach($option["BUTTONS"][0]["BUTTON"] as $bk => $bv)
		{
		  unset($item);
			@$item["type"]=$bv["ATTRIBUTES"]["TYPE"];
			@$item["label"]=$alang[$bv["ATTRIBUTES"]["LABEL"]];
			@$width = $option["ATTRIBUTES"]["WIDTH"];
			if (@!$width) $width=640;
			@$height = $option["ATTRIBUTES"]["HEIGHT"];
			if (@!$height) $height=480;
			$item["onclick"]='processdatagrid("'.$item["type"].'","'.$dialog.'","'.$this->Name.'","",'.$width.','.$height.',"",'.$this->count.');';
			switch ($item["type"]){
			  case 'removeall':
				case 'delete':
				case 'ch_delete':
				case 'up':
				case 'down':
				case 'ch_deliver':
				case 'ch_blacklist':
				case 'ch_refresh':
				case 'ch_whitelist':
				case 'bw_whitelist':
				case 'bw_blacklist':
					if ($type=="datagrid")	$nr = 'document.getElementById("noreload").value=1;';
					else $nr = '';
					$item["onclick"]=$nr.'document.getElementById("gridval").value="'.$this->Name.'";document.getElementById("gridaction").value="'.$item["type"].'";document.forms[0].submit();';
				break;
				
		}
		   $items[]=$item;
		}
		return $items;
	}
}
?>
