<?php
require_once "inc/syntax/clsstdgrid.php";
/***************** Schedule grid ***********************/
class cScheduleGrid extends cStdGrid
{
	function cScheduleGrid($name)
	{
	  global $remote;
		$this->Name = strtolower($name);
		
		//Remote account schedule
		if ($this->Name=="ra_schedule")
    { 
          $this->RA_Schedule = true;
          $remote->Open($_REQUEST['fileid']);
    }
    
    //Task & Events schedule
		if ($this->Name=="taskeventschedule") 
          $this->TaskEvent = true;
		
		//DEBUG
		//die();
	  //echo $remote->getProperty("RA_Name");
	}

  function LoadFromAPI()
  {
    global $days,$formapi,$remote,$_REQUEST;
    if ($this->RA_Schedule) $schedule = $remote->GetSchedule($this->Name);else
    if ($this->TaskEvent){
        $schedule = createobject('schedule');
        $schedule->SetProperty('s_backup',$_REQUEST['fileid']);
    } else $schedule = $formapi->GetSchedule($this->Name);

    for ($i = 0; $i< $schedule->Count; $i++){
      $schedule->Select($i);
      for ($j = 0; $j< 7;$j++)
        $bin[$j] = !$schedule->GetProperty("s_weekdays_".$days[$j]);


		  $item["s_weekdays"] = binary2decimal($bin);
   
      $item["s_scheduletype"] = $schedule->GetProperty("s_scheduletype");
      if($item["s_scheduletype"] == 0){
        $val = $schedule->GetProperty("s_every");
        $item["s_every"]=parseTime("hour","min",$val);
      }
      if ($item["s_scheduletype"] == 1){
          $val = $schedule->GetProperty("s_onceat");
          $item["s_onceat"] = parseTime("seconds","shour",$val);
        
      }
      $item["s_wholeday"] = $schedule->GetProperty("S_WholeDay");
      if (!$item["s_wholeday"]) {
        $item["s_betweenfrom"] = parseTime("seconds","shour",$schedule->GetProperty("S_BetweenFrom"));
        $item["s_betweento"] = parseTime("seconds","shour",$schedule->GetProperty("S_BetweenTo"));
      }
      $items[] = $item;
    }
    $this->Data = $items;
  }

  function SaveToAPI()
  {
    global $days,$formapi,$remote;
    $schedule = createobject("schedule");
   
  if ($this->Data)
  //!--Handle this 
    foreach($this->Data as $key => $item){
      $schedule->Add();
      $bin = decimal2binary($item["s_weekdays"]);
      for ($j = 0; $j< 7;$j++)
        $schedule->SetProperty("s_weekdays_".$days[$j],!$bin[$j]);
      $schedule->SetProperty("s_scheduletype",$item["s_scheduletype"]);
     if($item["s_scheduletype"] == 0)
        $schedule->SetProperty("s_every",parseTime("min","hour",$item["s_every"]));
      if ($item["s_scheduletype"] == 1)
        $schedule->SetProperty("s_onceat",parseTime("shour","seconds",$item["s_onceat"]));
   
      $schedule->SetProperty("s_wholeday",$item["s_wholeday"]);
      if (!$item["s_wholeday"]) {
        $schedule->SetProperty("s_betweenfrom",parseTime("shour","seconds",$item["s_betweenfrom"]));
        $schedule->SetProperty("s_betweento",parseTime("shour","seconds",$item["s_betweento"]));
      }
    }

      //Handle this--! 
     if ($this->RA_Schedule){
        $remote->SetSchedule($this->Name,$schedule);
        $remote->Save(); 
      }
      else{
          $api = createobject("api");   
          $api->SetSchedule($this->Name,$schedule);
          $api->Save(); 
     }
     unset($_SESSION['griddata']['grids'][$this->Name]); 
   
  }
  function Load($gObj,$array)
  {
  		if (is_array($gObj->Base[$this->Name])){
       $this->LoadFromSession($gObj);
      }
      else  {
      $this->LoadFromAPI();
      }
      if (!$array) $this->SaveToSession($gObj);
  }
  function LoadFromSession($gObj)
  {
    //echo '<pre>';_r($gObj);echo '</pre>';die();
    $this->Data = $_SESSION['griddata']['grids'][$this->Name];
  }
  function getObjectJS($selector,$vindex,$aFunction = false,$option)
	{
		global $alang,$skin_dir,$sGridItem,$days,$dayslang;
		/*selector name */
		$arr["dname"] = $this->Name;

		@$files = $option["SOURCE"][0]["FILE"][0]["ATTRIBUTES"];
		@$dialog = $files["DIALOG"];
		@$file = $files["NAME"];
		@$comment = $files["COMMENT"];
		@$width = $option["ATTRIBUTES"]["WIDTH"];
		if (@!$width) $width=640;
		@$height = $option["ATTRIBUTES"]["HEIGHT"];
		if (@!$height) $height=480;
		
		if ($this->Data)
		foreach($this->Data as $key2 => $val2){
			$label="";
			if ($val2["s_scheduletype"]==0) 
			 $label.=$alang["TAntivirusSettingForm_EveryMinutes"]." ".$val2["s_every"];
      if ($val2["s_scheduletype"]==1) 
			 $label.=$alang["TAntivirusSettingForm_OnceAt"]." ".$val2["s_onceat"];
			$label.="[";
			$bin = decimal2binary($val2["s_weekdays"]);
			$count = 0;$count2 = 0;

      for ($i = 0; $i<7 ; $i++)
			 if(!$bin[$i]) $count++;

			for ($i = 0; $i<7 ; $i++)
			 if(!$bin[$i]){
           $count2++;
           $label.=$alang[$dayslang[$i]];
           if($i!=6 && $count!=$count2) $label.=",";
        }
			$label.="]";
			
			$arr["items"]["num"][$key2]["num"][0] = $label;
			$arr["items"]["num"][$key2]["cislo"]= $key2;
			if ($this->Name.$key2==$sGridItem) $arr["items"]["num"][$key2]["selected"]=1;
		}
		$arr["selector"]=$selector;
		return template($skin_dir."dgridjs2.tpl",$arr);
	}
  function Save()
  {
    $this->saveToAPI();
  }
}

?>
