_me = frm_insert_item.prototype;
function frm_insert_item(){};

_me.__constructor = function(aResponse) {

	var me = this;

	this._title('INSERT_ITEM::INSERT_ITEM');
	this._size(800,500);
	
	// TODO remember account and folder directly in datagrid instead of in path in dataset

	// Create formular from template

	this._draw('frm_insert_item', 'main');
	
	this.tree_folder._open(sPrimaryAccount);
	this.datagrid._listen_data(me._name);

	this.tree_folder._onclick = function(e,elm,id,arg)
	{
	  if (e.type != 'contextmenu' && arg['aid'] && arg['fid'])
		{
			var aItems = dataSet.get(me._name);
			var sFolType = dataSet.get("folders",[arg['aid'],arg['fid'],'TYPE']);

			me.datagrid._refreshHeader = true;

			if (!Is.Defined(aItems) || !Is.Defined(aItems[arg['aid']]) || !Is.Defined(aItems[arg['aid']][arg['fid']]))
			{
				var items = new wm_items;
				var aValues = items.default_values(arg['fid'],sFolType);
				items.list({'aid':arg['aid'],'fid':arg['fid'],'values':aValues}, me._name);
			}
			else
        me.datagrid._fill();
			
		    if (sFolType == 'M')
				{
		        me.radio._disabled(true);
		        me.radio._value('embedded');
		    }
				else
		    	me.radio._disabled(false);
	  }
	}
	
	this.datagrid._onclick = null;

	this.datagrid._ondblclick = function(e,elm,etr,arg)
	{
		me.x_btn_ok._onclick();
	}
	
	// This function is triggered when 'OK' button is pressed.
	this.x_btn_ok._onclick = function() {

		var aItems = me.datagrid._value();

		if (Is.Defined(aItems)) {
		    var aDataset = dataSet.get(me._name);
			for(var sAccId in aDataset)
				for(var sFolId in aDataset[sAccId]);

			var aResult = [];

            var sTitle;
		    for (var i in aItems) {
		        var aItem = aDataset[sAccId][sFolId][aItems[i]];

				switch (dataSet.get("folders", [sAccId, sFolId, 'TYPE'])) {
					case 'M': sTitle = aItem['SUBJECT']; break;
					case 'C': sTitle = aItem['ITMCLASSIFYAS']; break;
					case 'F': sTitle = aItem['EVNLOCATION']; break;
					case 'E':
					case 'J': 
					case 'N':
					case 'T': sTitle = aItem['EVNTITLE']; break;
				    default: sTitle = getLang('INSERT_ITEM::UNTITLED');
				}
				aResult.push({
					'id': aItems[i],
					'title': sTitle,
					'fullpath': sAccId+'/'+sFolId+'/'+aItems[i],
					'embedded': me.radio._value() == 'embedded'
				});
			}
		    if (Is.Defined(aResponse)) executeCallbackFunction(aResponse, aResult);
		}

		me._destruct();
	}
	
	this._onclose = function() { dataSet.remove(me._name); return true; }
};
