<?php
require_once "privateandpublic.php";
/**
 * @brief		Class for handling webmailIqPublic namespace
 *				Only Administrs can change this files
 * @date		 16.6.2005
 */
class WebmailIqDomain extends PrivateAndPublic
{
		//protected $sFilterPath = 'domain'; //  Private: path into xml filters directory
    protected $sPP = 'domain';
		/**
		* @brief		Public: Constructor
		* @param		aInputXML		Array that contains subrequest
		*				aAttrs			Array that contains IQ attributes
		*/
		public function __construct($oDOMQuery,&$oDOMDoc,&$attrs)
		{
				$this->oDOMQuery = $oDOMQuery;
				$this->oDOMDoc = &$oDOMDoc;
				$this->aAttrs = &$attrs;
				$this->aAttts['private'] = false;

				/* get filename */
				if (!$this->oResources = $this->oDOMDoc->query("$this->sPP:resources/$this->sPP:*",
                                                      $this->oDOMQuery))
					  throw new Exc($aError['p_store_node_missing']);

				/* basic input check */
				parent::CheckInputXML();
				  
				/* check filename */
				Security::checkpath($this->sFile);
				  
				/* check for filter existency (Filter is mandatory in Public mode) */
				$this->checkInputXML();
				  
				/* execute input */
				$this->exeInputXML();

		}

		/**
		* @brief		Private: input check
		*/
		private function checkInputXML()
		{
				if ($_SESSION['ACCOUNT']==0)
				  throw new Exc('Access denied');
		}
		//DO NOW !!!!!!!!!!!!!!
		protected function set($sResourceName,$aActions)
		{
        $default = Storage::getDefaults($sResourceName); 
        $domain = Storage::getDomainDefaults($sResourceName);
        if ($aActions)
          foreach($aActions as $action){
            $newdata['@childnodes']['item'][] = $action['dataTree'];
          }

        if (!$domain){
          $items = $newdata;
          $accessTag = Storage::$rightType[$_SESSION['ACCOUNT']];
        }
        //Merge 
        else{
          //FIXME : delete old data?
          if (in_array($sResourceName,self::$aNonMergingResources))
            unset($domain['@childnodes']['item']);
          
          $items = Storage::mergeResource($domain,$newdata,$default,true,Storage::$rightTyte[2]);
          
          $accessTag = 'access';
        }

      return $items;
    }
    
}

?>
