<?php

require_once 'error.php';

/**
 * @brief  class for handling webmailIqItems namespace
	@author Pavel Perna
	@date	04.04.2006
 */
 class WebmailIqHolidays extends XMLRequestInterface {
		
		/**
		* @brief Public: Constructor
		* @param $oQuery A DOMElement filled with query element
		* @param $oDoc	A DOMDocument of the request
		* @param $attrs  An Array with parent attributes
		*/
		public function __construct($oQuery,&$oDoc,&$attrs)
		{
				$this->oQuery = $oQuery;
				$this->oDoc = &$oDoc;
				$this->aAttrs = &$attrs;

				$this->checkInputXML();
				$this->exeInputXML();

		}	
		
	  /**
		* @brief	Private - Checks if the input XML is valid
		* @return  TRUE/FALSE and throws exception
		*/		
		private function checkInputXML()
		{
		}

	  /**
		* @brief	Private: Do operations dependent on 'query xmlns'
		* @return		XML subanswer (string)
		*/
		private function exeInputXML()
		{		
				switch($this->aAttrs["type"])
				{
					case "get":		  
						$this->sTemplateFile = 'webmailiqholidays_get';
						 
						// GroupWare API object
						!$this->oGWAPI = &$_SESSION['pGWAccount']->gwAPI;
						
						// Get Holidays depending on specified email
						$sHolidays = $this->oGWAPI->FunctionCall("AddHolidays",
																  $this->oGWAPI->sessid,"");
						// Parse holidays param line
						$aHolidays = $this->oGWAPI->ParseParamLine($sHolidays);
						
						print_r($aHolidays);
						
						// Parse versit data into return array for template 
						// $this->aData["holidays"]["num"] = $this->cnvHolidays($aHolidays);
						break;
					
					case "set":
						
						break;
				}
				
				 
		}
	  
	  /**
		* @brief	Private: converts Holiday array to template data format
		* @param	$sHolidays Holiday array as result of ParseParamLine($holidayLine)
		* @return  parsed data array for templates
		*/  
		private function cnvHolidays($aHolidays)
		{
			  foreach($aHolidays as $holiday)
			  {
					
			  }
			  return $aHolidays;
		}
 }
		
?>
