<?php

chdir('..');

require_once('inc/get.php');
require_once('inc/user.php');

if (($sid = Get()->sid) === null)
	exit('Invalid sid');
if (($account_id = Get()->getInt('account_id')) === null)
	exit('Invalid account_id');
if (($folder_id = Get()->folder_id) === null)
	exit('Invalid folder_id');

$user = User::load($sid);
$account = $user->getAccount($account_id);
$folder = $account->getFolder($folder_id);
$folder->sync();

?>
