<?php

chdir('..');

require_once('inc/get.php');
require_once('inc/user.php');
require_once('inc/mail.php');

if (($sid = Get()->sid) === null)
	exit('Invalid sid');
if (($account_id = Get()->getInt('account_id')) === null)
	exit('Invalid account_id');
if (($folder_id = Get()->folder_id) === null)
	exit('Invalid folder_id');
if (($srcFolder = Get()->folder) === null)
	exit('Invalid folder');

$user = User::load($sid);
$account = $user->getAccount($account_id);
$folder = $account->getFolder($folder_id);
$mail = new Mail();
$mail->setFrom('martin.zlomek@itonis.tv');
$mail->addTo('martin.zlomek@email.cz');
$mail->addCC('mates@icewarp.com');
$mail->addBCC('martin.zlomek@tiscali.cz');
$mail->addReplyTo('martin.zlomek@itonis.tv');
$mail->setSubject('Test');
$mail->setBody("Testovaci\nmail", '<p>Testovaci</p><p>mail</p>');
foreach ($user->getAttachments($srcFolder) as $attachment)
	$mail->addAttachment($attachment['file'], $attachment['type']);
$folder->createItem($mail->getMessage());
$user->removeAttachments($srcFolder);

?>
