<?php

chdir('..');

require_once('inc/get.php');
require_once('inc/user.php');

if (($sid = Get()->sid) === null)
	exit('Invalid sid');
if (($account_id = Get()->getInt('account_id')) === null)
	exit('Invalid account_id');
if (($folder_id = Get()->folder_id) === null)
	exit('Invalid folder_id');
if (($item_id = Get()->getInt('item_id')) === null)
	exit('Invalid item_id');
if (($flags = Get()->flags) === null)
	exit('Invalid flags');

$user = User::load($sid);
$account = $user->getAccount($account_id);
$folder = $account->getFolder($folder_id);
$item = $folder->getItem($item_id);
$item->unsetFlags($flags);

?>
