<?php

chdir('..');

require_once('inc/get.php');
require_once('inc/user.php');
require_once('inc/include.php');
require_once('inc/xmlrequest.php');
require_once('inc/webmailiqitems.php');

if (($sid = Get()->sid) === null)
	exit('Invalid sid');
if (($account_id = Get()->account_id) === null)
	exit('Invalid account_id');
if (($folder_id = Get()->folder_id) === null)
	exit('Invalid folder_id');

$user = User::load($sid);
$account = $user->getAccount($account_id);
$folder = $account->getFolder($folder_id);

echo '<pre>';
//print_r($folder->getItems());
$items = WebmailIqItems::cnvItems($folder->getItems());
foreach ($items as $item)
{
	echo htmlspecialchars($item['sFields'])."\r\n";
}
echo '</pre>';
?>
