#!/bin/sh
##
# This file is the skeleton for all add-on scripts you may write.
# It's sole purpose is to initialise the environment and give you
# access to common functions
#
# If you make something really useful, share it with others.
# Credits shall be given to those who do so.
##

functions()
	{
		SELFTMP=$0
		ORIGPWD=`pwd`
		REALPWD=`dirname $0`
		cd "$REALPWD"
		while [ -L "$SELFTMP" ]
			do
				SELFTMP=`readlink "$SELFTMP"`
				cd `dirname "$SELFTMP"`
				REALPWD=`pwd -P`
		done

		cd "$ORIGPWD"
				
		if [ "$INITIALIZED" != "1" ]
		        then
	                source $REALPWD/inc/functions.sh
		fi
	}

functions

#
# put your script below this comment
# don't hardcode any value or path, use the ones available from functions.sh
#

good "This is just a skeleton. See the Source."